.\"	$NetBSD: firmload.9,v 1.4 2008/04/30 13:10:58 martin Exp $
.\"
.\" Copyright (c) 2006 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to The NetBSD Foundation
.\" by Jason R. Thorpe.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd January 17, 2006
.Dt FIRMLOAD 9
.Os
.Sh NAME
.Nm firmload
.Nd Firmware loader API for device drivers
.Sh SYNOPSIS
.In dev/firmload.h
.\"
.Ft int
.Fn "firmware_open" "const char *drvname" "const char *imgname" \
"firmware_handle_t *fhp"
.\"
.Ft int
.Fn "firmware_close" "firmware_handle_t fh"
.\"
.Ft off_t
.Fn "firmware_get_size" "firmware_handle_t fh"
.\"
.Ft int
.Fn "firmware_read" "firmware_handle_t fh" "off_t offset" "void *buf" \
"size_t size"
.\"
.Ft void *
.Fn "firmware_malloc" "size_t size"
.\"
.Ft void
.Fn "firmware_free" "void *buf" "size_t size"
.Sh DESCRIPTION
.Nm
provides a simple and convenient API for device drivers to load firmware
images from files residing in the file system that are necessary for the
devices that they control.
Firmware images reside in sub-directories, one for each driver, of a series
of colon-separated path prefixes specified by the sysctl variable
.Dv hw.firmware.path .
.Pp
The following functions are provided by the
.Nm
API:
.Bl -tag -width indent
.It int Fn "firmware_open" "const char *drvname" "const char *imgname" \
"firmware_handle_t *fhp"
.Pp
Open then firmware image
.Fa imgname
for the driver
.Fa drvname .
The path to the firmware image file is constructed by appending the string
.Dq "/drvname/imgname"
to each configured path prefix until opening the firmware image file succeeds.
Upon success,
.Fn firmware_open
returns 0 and stores a firmware image handle in the location pointed to by
.Fa fhp .
Otherwise, an error code is returned to indicate the reason for failure.
.It int Fn "firmware_close" "firmware_handle_t fh"
.Pp
Close the firmware image file associated with the firmware handle
.Fa fh .
Returns 0 upon success or an error code to indicate the reason for failure.
.It off_t Fn "firmware_get_size" "firmware_handle_t fh"
.Pp
Returns the size of the image file associated with the firmware handle
.Fa fh .
.It int Fn "firmware_read" "firmware_handle_t fh" "off_t offset" "void *buf" \
"size_t size"
.Pp
Reads from the image file associated with the firmware handle
.Fa fh
beginning at offset
.Fa offset
for length
.Fa size .
The firmware image data is placed into the buffer specified by
.Fa buf .
Returns 0 upon success or an error code to indicate the reason for failure.
.It void * Ns Fn "firmware_malloc" "size_t size"
.Pp
Allocates a region of wired kernel memory of size
.Fa size .
Note:
.Fn firmware_malloc
may block.
.It void Fn "firmware_free" "void *buf" "size_t size"
.Pp
Frees a region of memory previously allocated by
.Fn firmware_malloc .
.El
.Sh SEE ALSO
.Xr autoconf 9 ,
.Xr malloc 9 ,
.Xr vnsubr 9
.Sh HISTORY
The
.Nm
framework first appeared in
.Nx 4.0 .
.Sh AUTHORS
.An Jason Thorpe Aq thorpej@NetBSD.org
